unit CaptionEditForm;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls;

type
  TFormCaptionEdit = class(TForm)
    MemoEdit: TMemo;
    Label1: TLabel;
    Button1: TButton;
    Button2: TButton;
    Label2: TLabel;
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
  private
    function GetCaptionStr: string;
    procedure SetCaptionStr(const Value: string);
    { Private declarations }
  public
    { Public declarations }
    function Execute: Boolean; overload;
    function Execute(ACaption: string): Boolean; overload;
    property CaptionStr: string read GetCaptionStr write SetCaptionStr;
  end;


function CaptionEditor: TFormCaptionEdit;  

implementation

{$R *.dfm}

var
  tagCaptionEditor: TFormCaptionEdit;

procedure InitEditor;
begin
  if not Assigned(tagCaptionEditor) then
    tagCaptionEditor := TFormCaptionEdit.Create(nil);
end;

procedure DoneEditor;
begin
  if Assigned(tagCaptionEditor) then
    FreeAndNil(tagCaptionEditor);
end;

function CaptionEditor: TFormCaptionEdit;
begin
  InitEditor;
  Result := tagCaptionEditor;
end;


{ TFormCaptionEdit }

function TFormCaptionEdit.Execute(ACaption: string): Boolean;
begin
  CaptionStr := ACaption;
  Result := Execute;
end;

function TFormCaptionEdit.Execute: Boolean;
begin
  Result := (ShowModal = mrOk);
end;

function TFormCaptionEdit.GetCaptionStr: string;
begin
  Result := MemoEdit.Text;
end;

procedure TFormCaptionEdit.SetCaptionStr(const Value: string);
begin
  MemoEdit.Text := Value;
end;

procedure TFormCaptionEdit.Button1Click(Sender: TObject);
begin
  Close;
end;

procedure TFormCaptionEdit.Button2Click(Sender: TObject);
begin
  Close;
end;

end.
